require_relative 'spell_error'
require_relative 'spell_request'
require 'json'

module YanSpeller
  class Speller
    attr_reader :status

    def initialize
      @spell_request = SpellRequest.new
      @errors = []
      @status = :request_fail
    end

    def check_spell text
      result = @spell_request.send text
      if @spell_request.success?
        @errors = JSON.parse(result.body).map do |err|
          SpellError.new err
        end
        @status = @errors.empty? ? :no_spell_errors : :spell_errors
      else
        @status = :request_fail
      end
    end

    def errors_to_s
      @errors.map { |err| err.to_s }
    end

  end	 
end